/*
 * This file is part of xsoundtrack - a sound tracker for Linux.
 * Sed - july august 1998.
 * This is total free software.
 *-------------------------------------
 */

#ifndef _INTERFACE_H_
#define _INTERFACE_H_

#include <X11/Xlib.h>

#include "xm.h"

extern char *name_note[12];

/* this should be in file_selector.h, but the two .h would have need each other, so problem.
 * Solution : put it here. Very bad.
 */
typedef struct {
  int in_use;
  char *out_name;
  Window window;
  Pixmap pixmap;
  int cur_pos;
  int mode;
  int down_0;
  /* data used for the contents of a dir handling */
  char **files;
  char **dirs;
  int nb_files;
  int nb_dirs;
  int file_start;
  int dir_start;
  int file_pos;
  int dir_pos;
} FILE_SELECTOR;

typedef struct {
  /* the screen-stuff */
  Display *X_ecran;
  GC context;
  /* the fonts */
  Font little;
  Font medium;
  Font big;
  Font title;
  /* the menu-window */
  Window menu;
  /* redraw all on each Expose is too slow. Use a pixmap instead */
  Pixmap menu_pixmap;
  /* the xms handled by this interface */
  XM **xms;
  int nb_xms;
  /* the currently edited xm (where the pointer is */
  XM *current_xm;
  /* the menu current button */
  int current_menu_button;
  /* the file selector (only used when a file selector is present, only one file selector at a time
   * and when a file selector is here, all the rest is blocked) */
  FILE_SELECTOR file_selector;
  /* the cut-buffer comes here. It is a global thing, so we can cut/copy samples between modules. Cool, eh ?
   * You can rip easilly.
   * those data are not initialised, but in interface.init_interface there's a memset(0), so, no problem
   */
  char *cut_buffer_data;
  unsigned long cut_buffer_length;	/* bytes unit */
  int cut_buffer_type;		/* 0 = 8b 1 = 16b */
  int cut_buffer_in_use;	/* 0 = no 1 = yes */
  /* record flag (put when we want to record a sample) */
  int in_record;
  /* this is set by the record function of sub_sample.c (used because when in record mode, we can't do something else)  */
  Window record_window;
} INTERFACE;

/* the functions */
int init_interface(INTERFACE *);
void close_interface(INTERFACE *);
int init_xm_interface(INTERFACE *, XM *);
void close_xm_interface(INTERFACE *, XM *);
void put_name_xm(INTERFACE *, XM *);
void handle_event(INTERFACE *);

/* some definitions */

/* the state of the interface */
#define MOVING		1
#define EDIT		2

/* 3d drawing stuff */
#define UP_3D   1		/* this is a square that seems to go out of the screen */
#define DOWN_3D 2		/* this one seems to enter in the screen */

/* button around stuff */
#define IN	1		/* around the button must be drawn */
#define OUT	2		/* must be cleaned */

/* arrows type */
#define ARROW_UP	1
#define ARROW_DOWN	2
#define ARROW_LEFT	3
#define ARROW_RIGHT	4

#define XDD (148-6*6+4)
#define NNX (12+12)
#define ADX (100+50+10+1)
#define ADY 100

#define XS9		(170)
#define YS9		(110)

#endif /* _INTERFACE_H_ */
