/*
 * This file is part of xsoundtrack - a sound tracker for Linux.
 * Sed - july august 1998.
 * This is total free software.
 *-------------------------------------
 * the interface main file.
 */

/* a little main-test */
#include <stdio.h>

/* includes from ../player */
#include "card.h"
#include "xm.h"
#include "mixer.h"
/* local includes */
#include "interface.h"

/* not a good idea to call it real_main, but have no other in mind */
void real_main(INTERFACE *i)
{
  void draw_patterns(INTERFACE *, XM *);
  void draw_patterns_order(INTERFACE *, XM *);
  void draw_default_bpm(INTERFACE *, XM *);
  void draw_default_speed(INTERFACE *, XM *);

  handle_event(i);
  if (i->current_xm && i->current_xm->mix)
    mix(i->current_xm);
  if (i->current_xm) {
    if (i->current_xm->new_line) {
      i->current_xm->new_line=0;
      draw_patterns(i, i->current_xm);
    }
    if (i->current_xm->new_pattern) {
      i->current_xm->new_pattern=0;
      draw_patterns_order(i, i->current_xm);
    }
    if (i->current_xm->new_tempo) {
      i->current_xm->new_tempo=0;
      draw_default_bpm(i, i->current_xm);
      draw_default_speed(i, i->current_xm);
    }
  }
}

void main(int nb, char **arg)
{
  INTERFACE interface;

  if (!init_interface(&interface)) {
    fprintf(stderr, "Error while initing the interface (are you under X-window ?)\n");
    exit(1);
  }

  /* initing the card */
  if (!init_sound(44100, 16, 1)) { /* 1 is for stereo */
    fprintf(stderr, "error with initing the soundcard (some other program already using it ?), bye bye\n");
    exit(1);
  }

  if (!init_mixer(44100, 16, 1)) {
    fprintf(stderr, "error with initing the soft-mixer, bye bye\n");
    exit(1);
  }

  while(1)
    real_main(&interface);

  close_sound();
  close_interface(&interface);
}
