/*
 * This file is part of xsoundtrack - a sound tracker for Linux.
 * Sed - july august september 1998.
 * This is total free software.
 *-------------------------------------
 * The sample editor. Viewing. See sub_sample.c for each subwindow handling and sample_moving.c for when in moving mode.
 */

/* It is very possible that you'll find bugs (core-dumping bugs, i mean) in this file. */

#include "sample.h"

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "interface.h"
#include "xm.h"
#include "screen.h"
#include "sample_moving.h"
#include "sub_sample.h"

void init_view_0(INTERFACE *i, sample *samp)
{
  /* loop start, loop end */
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XI+5, YI+5, 148-6*6, 74, 6, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, XI+9+6, YI+1+5+4+8+11-5, "Loop", i->little, 0);
  draw_string(i->X_ecran, samp->pixmap, i->context, XI+9, YI+1+5+4+8+11+5, "start", i->little, 0);
  draw_string(i->X_ecran, samp->pixmap, i->context, XI+9+6, YI+1+5+4+13+3+13+6+8+11-5, "Loop", i->little, 0);
  draw_string(i->X_ecran, samp->pixmap, i->context, XI+9+6*2, YI+1+5+4+13+3+13+6+8+11+5, "end", i->little, 0);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XI+9+6*10+5-5*6, YI+1+5+4, UP_3D, ARROW_UP);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XI+9+6*10+5-5*6, YI+1+5+4+13+3, UP_3D, ARROW_DOWN);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XI+9+6*10+5-5*6, YI+1+5+4+13+3+13+6, UP_3D, ARROW_UP);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XI+9+6*10+5-5*6, YI+1+5+4+13+3+13+6+13+3, UP_3D, ARROW_DOWN);
  /* fine tune, relative tone */
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XFR+5, YI+5, 148-6*6+3*6-4*6, 74, 6, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, XFR+9+6*4, YI+1+5+4+8+11-5, "Fine", i->little, 0);
  draw_string(i->X_ecran, samp->pixmap, i->context, XFR+9+6*4, YI+1+5+4+8+11+5, "tune", i->little, 0);
  draw_string(i->X_ecran, samp->pixmap, i->context, XFR+9, YI+1+5+4+13+3+13+6+8+11-5, "Relative", i->little, 0);
  draw_string(i->X_ecran, samp->pixmap, i->context, XFR+9+6*4, YI+1+5+4+13+3+13+6+8+11+5, "tone", i->little, 0);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XFR+9+6*10+5-2*6, YI+1+5+4, UP_3D, ARROW_UP);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XFR+9+6*10+5-2*6, YI+1+5+4+13+3, UP_3D, ARROW_DOWN);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XFR+9+6*10+5-2*6, YI+1+5+4+13+3+13+6, UP_3D, ARROW_UP);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XFR+9+6*10+5-2*6, YI+1+5+4+13+3+13+6+13+3, UP_3D, ARROW_DOWN);
  /* volume, panning */
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XVP+5, YI+5, 148-6*6+3*6-7*6, 74, 6, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, XVP+9+6, YI+1+5+4+8+11, "Volume", i->little, 0);
  draw_string(i->X_ecran, samp->pixmap, i->context, XVP+9, YI+1+5+4+13+3+13+6+8+11, "Panning", i->little, 0);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XVP+9+6*10+5-3*6, YI+1+5+4, UP_3D, ARROW_UP);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XVP+9+6*10+5-3*6, YI+1+5+4+13+3, UP_3D, ARROW_DOWN);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XVP+9+6*10+5-3*6, YI+1+5+4+13+3+13+6, UP_3D, ARROW_UP);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XVP+9+6*10+5-3*6, YI+1+5+4+13+3+13+6+13+3, UP_3D, ARROW_DOWN);
  /* 8/16 bits */
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XHS+5, YI+5, 148-6*6+3*6-7*6-3*6-2, 74, 6, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, XHS+9+6, YI+1+5+4+11+1, "8 bits", i->little, 0);
  draw_string(i->X_ecran, samp->pixmap, i->context, XHS+9, YI+1+5+4+8+11+15+1, "16 bits", i->little, 0);
  draw_string(i->X_ecran, samp->pixmap, i->context, XHS+9, YI+1+5+4+8+11+15+25+1, "Convert", i->little, 0);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XHS+9+6*10+5-3*6, YI+1+5+4+11-9+1, 10, 10, LIGHTBLUE, UP_3D);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XHS+9+6*10+5-3*6, YI+1+5+4+8+11+15-9+1, 10, 10, LIGHTBLUE, UP_3D);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XHS+9+6*10+5-3*6, YI+1+5+4+8+11+15-9+25+1, 10, 10, LIGHTBLUE, UP_3D);
  /* use loop (i forgot that ! what a loser */
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XL, YI+5, 6*10+8+10+1, 18+12+18+4, GREY, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, XL+6, YI+5+12, "Loop type :", i->little, 0);
  /* and type of loop. Forgotten too... damned... */
  draw_string(i->X_ecran, samp->pixmap, i->context, XL+6*3, YI+5+12+18+4-5, "Forward", i->little, 0);
  draw_string(i->X_ecran, samp->pixmap, i->context, XL+6, YI+5+12+18+4+15-5, "Ping-pong", i->little, 0);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XL+6*10+4, YI+5+4+18+4-5, 10, 10, LIGHTBLUE, UP_3D);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XL+6*10+4, YI+5+4+18+4+15-5, 10, 10, LIGHTBLUE, UP_3D);
  /* cut, copy, paste buttons */
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XL, YI+5+18+4+18+4+12, 3*6+12, 18, LIGHTBLUE, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, XL+6, YI+5+12+18+4+18+4+12, "Cut", i->little, 0);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XL+6*3+12+4, YI+5+18+4+18+4+12, 4*6+12, 18, LIGHTBLUE, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, XL+6*3+12+4+6, YI+5+12+18+4+18+4+12, "Copy", i->little, 0);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XL+6*3+12+4+4*6+12+4, YI+5+18+4+18+4+12, 5*6+12, 18, LIGHTBLUE, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, XL+6*3+12+4+6+4*6+12+4, YI+5+12+18+4+18+4+12, "Paste", i->little, 0);
}

void init_view_1(INTERFACE *i, sample *samp)
{
  /* mixing rate, 8/16 bits */
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XI+5, YI+5, 148-8*6, 74, 6, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, XI+9, YI+1+5+4+8+11-5, "Mixing", i->little, 0);
  draw_string(i->X_ecran, samp->pixmap, i->context, XI+9+6*2, YI+1+5+4+8+11+5, "rate", i->little, 0);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XI+9+6*10+5-4*6, YI+1+5+4, UP_3D, ARROW_UP);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XI+9+6*10+5-4*6, YI+1+5+4+13+3, UP_3D, ARROW_DOWN);
  draw_string(i->X_ecran, samp->pixmap, i->context, XI+9+6, YI+1+5+4+8+11-5+10*3, "8 bits", i->little, 0);
  draw_string(i->X_ecran, samp->pixmap, i->context, XI+9, YI+1+5+4+8+11-5+10*5-5, "16 bits", i->little, 0);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XI+9+6*8, YI+1+5+4+8+11-5+10*3-9, 10, 10, LIGHTBLUE, UP_3D);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XI+9+6*8, YI+1+5+4+8+11-5+10*5-9-5, 10, 10, LIGHTBLUE, UP_3D);
  /* fragment size, nb of fragments */
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XFS+5, YI+5, 148-6*6+3*6-1*6, 74, 6, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, XFS+9+6, YI+1+5+4+8+11-5, "Fragment", i->little, 0);
  draw_string(i->X_ecran, samp->pixmap, i->context, XFS+9+6*5, YI+1+5+4+8+11+5, "size", i->little, 0);
  draw_string(i->X_ecran, samp->pixmap, i->context, XFS+9+6*4, YI+1+5+4+13+3+13+6+8+11-5, "Nb of", i->little, 0);
  draw_string(i->X_ecran, samp->pixmap, i->context, XFS+9, YI+1+5+4+13+3+13+6+8+11+5, "fragments", i->little, 0);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XFS+9+6*10+5-1*6, YI+1+5+4, UP_3D, ARROW_UP);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XFS+9+6*10+5-1*6, YI+1+5+4+13+3, UP_3D, ARROW_DOWN);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XFS+9+6*10+5-1*6, YI+1+5+4+13+3+13+6, UP_3D, ARROW_UP);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XFS+9+6*10+5-1*6, YI+1+5+4+13+3+13+6+13+3, UP_3D, ARROW_DOWN);
  /* micro in... */
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XMI, YI+5, 6*20+8+10, 18, GREY, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, XMI+6*3, YI+5+12, "Micro in    Line in", i->little, 0);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XMI+4, YI+5+4, 10, 10, LIGHTBLUE, UP_3D);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XMI+4+6*12, YI+5+4, 10, 10, LIGHTBLUE, UP_3D);
  /* input volume */
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XMI+5, YV+5, 148-6*6+3*6-7*6, 74-35, 6, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, XMI+9+6, YV+1+5+4+8+11-5, "Input", i->little, 0);
  draw_string(i->X_ecran, samp->pixmap, i->context, XMI+9, YV+1+5+4+8+11+5, "volume", i->little, 0);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XMI+9+6*10+5-4*6, YV+1+5+4, UP_3D, ARROW_UP);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, XMI+9+6*10+5-4*6, YV+1+5+4+13+3, UP_3D, ARROW_DOWN);
  /* go */
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XG, YI+5, 74+50, 74, LIGHTBLUE, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, XG+9, YI+5+55, "Go !", i->title, BLACK);
}

void init_view_2(INTERFACE *i, sample *samp)
{
  draw_string(i->X_ecran, samp->pixmap, i->context, 4, YI+5+55, "Not implemented yet...", i->title, RED);
}

void (*init_view[3])(INTERFACE *, sample *)= {
  init_view_0,
  init_view_1,
  init_view_2
};

void init_sample_pixmap(INTERFACE *i, sample *samp)
{
  /* not all is drawn here */
  /* the sample viewing-zone */
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, 4, 4, 512+8, 128+8, GREY, UP_3D);
  draw_box(i->X_ecran, samp->pixmap, i->context, 8, 8, 512, 128, LIGHTBLUE);
  /* the position bar (from 4+13+4+3 on a 512+8-13*2-4*2-6 length for the tiny bar) */
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, 4+13+4, 128+8+8, 512+8-13*2-4*2, 13, GREY, UP_3D);
  //draw_3d_box(i->X_ecran, samp->pixmap, i->context, 4+13+4+3, 128+8+8+3, 512+8-13*2-4*2-6, 7, LIGHTBLUE, UP_3D);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, 4, 128+8+8, UP_3D, ARROW_LEFT);
  draw_arrow(i->X_ecran, samp->pixmap, i->context, 4+512+8-13, 128+8+8, UP_3D, ARROW_RIGHT);
  /* view sample setting ... */
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, 4, 128+8+8+13+4, 6*(57-8-5*2)+8, 18, GREY, UP_3D);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, 8+8*6-3, 128+8+8+13+4+4, 10, 10, LIGHTBLUE, UP_3D);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, 8+19*6-3, 128+8+8+13+4+4, 10, 10, LIGHTBLUE, UP_3D);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, 8+(42-8-5)*6-3, 128+8+8+13+4+4, 10, 10, LIGHTBLUE, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, 8+6, 128+8+8+13+4+12,
	      "View :   Sample     Record    Effects", i->little, BLACK);
  /* close, load save buttons */
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XBOZ+4+6*57+8+4, 128+8+8+13+4, 6*5+8, 18, LIGHTBLUE, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, XBOZ+4+6*57+8+4+4, 128+8+8+13+4+12, "Close", i->little, BLACK);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XBOZ+4+6*57+8+4+6*5+8+4, 128+8+8+13+4, 6*4+8, 18, LIGHTBLUE, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, XBOZ+4+6*57+8+4+6*5+8+4+4, 128+8+8+13+4+12, "Load", i->little, BLACK);
  draw_3d_box(i->X_ecran, samp->pixmap, i->context, XBOZ+4+6*57+8+4+30+48, 128+8+8+13+4, 6*4+8, 18, LIGHTBLUE, UP_3D);
  draw_string(i->X_ecran, samp->pixmap, i->context, XBOZ+4+6*57+54+24+16, 128+8+8+13+4+12, "Save", i->little, BLACK);
  /* sample size info zone */
  //draw_box(i->X_ecran, samp->pixmap, i->context, 8+6*(57-8-5*2)+8+2, 128+8+8+13+4+2, 6*(10+8+1+2)+10-4, 18-4, LIGHTBLUE);
  draw_string(i->X_ecran, samp->pixmap, i->context, 4+4+6*(57-8-5*2)+8+6, 128+8+8+13+4+12, "Sample size", i->little, WHITE);
}

void draw_sample_size(INTERFACE *i, sample *samp)
{
  char s[15];
  draw_box(i->X_ecran, samp->pixmap, i->context, 4+4+6*(57-8-5*2)+8+6*11+6*2, 128+8+8+13+4+3, 6*(8)+4, 12, LIGHTBLUE);
  sprintf(s, "%8.8X", samp->sample_length);
  draw_string(i->X_ecran, samp->pixmap, i->context, 4+4+6*(57-8-5*2)+8+6*11+6*2+2, 128+8+8+13+4+3+10, s, i->little, BLUE);
}

void draw_bar(INTERFACE *i, sample *p, unsigned int start_pos, unsigned int length)
{
  draw_box(i->X_ecran, p->pixmap, i->context, 4+13+4+3, 128+8+8+3, 512+8-13*2-4*2-6, 13-6, GREY);
  if (length<=5)
    length=5;
  if (length+start_pos>=512+8-13*2-4*2-6)
    start_pos=512+8-13*2-4*2-6-length;
  draw_3d_box(i->X_ecran, p->pixmap, i->context, 4+13+4+3+start_pos, 128+8+8+3, length, 7, LIGHTBLUE, UP_3D);
}

/* one might think that all those >>32 are a waste of time, but there is none of it, simply because
 * machines are 32b (well, if you make it run on something else, let me know, but it surely won't run
 * correctly) and a long long is 64b, so takes 2 registers, so the >>32 means the upper register, so no
 * shift is done (well, will have to look the generated code to be sure i'm right)
 */
/* well, in the code, for :
  new_data=YDEP-((*(data+(cur_pos>>32)))>>1);
in draw_sample_8, i've got :
 8062e27:       8b 4d f0        movl   0xfffffff0(%ebp),%ecx
 8062e2a:       89 ca           movl   %ecx,%edx
 8062e2c:       31 c9           xorl   %ecx,%ecx
 8062e2e:       8b 7d fc        movl   0xfffffffc(%ebp),%edi
 8062e31:       8a 14 3a        movb   (%edx,%edi,1),%dl
 8062e34:       c0 fa 01        sarb   $0x1,%dl
 8062e37:       0f be d2        movsbl %dl,%edx
 8062e3a:       be 47 00 00 00  movl   $0x47,%esi
 8062e3f:       29 d6           subl   %edx,%esi
 8062e41:       89 75 f4        movl   %esi,0xfffffff4(%ebp)
as we can see there is
 8062e27:       8b 4d f0        movl   0xfffffff0(%ebp),%ecx
 8062e2a:       89 ca           movl   %ecx,%edx
 8062e2c:       31 c9           xorl   %ecx,%ecx
which simply could be :
				movl   0xfffffff0(%ebp),%edx
we have 2 more instructions than necessary.
Bad. But that's the compiler (gcc), not me. Hehe.
*/

void draw_sample_16(INTERFACE *i, sample *samp)
{
  short *data=(short *)samp->sample_data;
  unsigned long j, col;
  int old_data, new_data;
  unsigned long long cur_pos=(unsigned long long)samp->start_0<<32;
  unsigned int bar_start, bar_length;
  unsigned long left=1, right=0;

  if (samp->cut_in_use)
    left=samp->cut_pos_left,
    right=samp->cut_pos_right;

  /* draw the sample */
  col=cur_pos>>32>=left && cur_pos>>32<=right ? WHITE : BLUE;
  new_data=YDEP-((*(data+(cur_pos>>32)))>>9);
  draw_plot(i->X_ecran, samp->pixmap, i->context, XDEP, new_data, 1, col);
  for (j=1; j<512; j++) {
    cur_pos+=samp->inc_0;
    if (cur_pos>=(unsigned long long)(samp->sample_length/2)<<32)
      break;
    old_data=new_data;
    new_data=YDEP-((*(data+(cur_pos>>32)))>>9);
    col=cur_pos>>32>=left && cur_pos>>32<=right ? WHITE : BLUE;
    draw_plot(i->X_ecran, samp->pixmap, i->context, XDEP+j, new_data, 1, col);
    draw_line(i->X_ecran, samp->pixmap, i->context, XDEP+j-1, old_data, XDEP+j, new_data, col);
  }

  /* now, draw the bar */
  bar_length=(samp->inc_0*512*(512+8-13*2-4*2-6)/(samp->sample_length/2))>>32;
  bar_start=samp->start_0*(512+8-13*2-4*2-6)/(samp->sample_length/2);
  if (bar_length+bar_start>=512+8-13*2-4*2-6)
    bar_length=512+8-13*2-4*2-6-bar_start;
  draw_bar(i, samp, bar_start, bar_length);

  /* draw loop start / end */
  if (samp->sample_type&3) {
    unsigned long p1=samp->sample_loop_start>>1, p2=(samp->sample_loop_start+samp->sample_loop_length)>>1;
    /* start */
    if (p1>=samp->start_0 &&
	(unsigned long long)p1<<32<((unsigned long long)(samp->start_0)<<32)+512ll*samp->inc_0) {
      unsigned long x;
      x=((unsigned long long)(p1-samp->start_0)<<32)/samp->inc_0;
      draw_line(i->X_ecran, samp->pixmap, i->context, XDEP+x, 8, XDEP+x, 8+128, RED);
      draw_plot(i->X_ecran, samp->pixmap, i->context, XDEP+x-1, 8+125, 3, RED);
    }
    /* end */
    if (p2>=samp->start_0 &&
	(unsigned long long)p2<<32<((unsigned long long)(samp->start_0)<<32)+512ll*samp->inc_0) {
      unsigned long x;
      x=((unsigned long long)(p2-samp->start_0)<<32)/samp->inc_0;
      draw_line(i->X_ecran, samp->pixmap, i->context, XDEP+x, 8, XDEP+x, 8+128, RED);
      draw_plot(i->X_ecran, samp->pixmap, i->context, XDEP+x-1, 8, 3, RED);
    }
  }
}

void draw_sample_8(INTERFACE *i, sample *samp)
{
  char *data=(char *)samp->sample_data;
  unsigned long j, col;
  int old_data, new_data;
  unsigned long long cur_pos=(unsigned long long)samp->start_0<<32;
  unsigned int bar_start, bar_length;
  unsigned long left=1, right=0;

  if (samp->cut_in_use)
    left=samp->cut_pos_left,
    right=samp->cut_pos_right;

  /* draw the sample */
  new_data=YDEP-((*(data+(cur_pos>>32)))>>1);
  draw_plot(i->X_ecran, samp->pixmap, i->context, XDEP, new_data, 1, BLUE);
  for (j=1; j<512; j++) {
    cur_pos+=samp->inc_0;
    if (cur_pos>=(unsigned long long)samp->sample_length<<32)
      break;
    old_data=new_data;
    new_data=YDEP-((*(data+(cur_pos>>32)))>>1);
    col=cur_pos>>32>=left && cur_pos>>32<=right ? WHITE : BLUE;
    draw_plot(i->X_ecran, samp->pixmap, i->context, XDEP+j, new_data, 1, col);
    draw_line(i->X_ecran, samp->pixmap, i->context, XDEP+j-1, old_data, XDEP+j, new_data, col);
  }

  /* now, draw the bar */
  bar_length=(samp->inc_0*512*(512+8-13*2-4*2-6)/samp->sample_length)>>32;
  bar_start=samp->start_0*(512+8-13*2-4*2-6)/samp->sample_length;
  if (bar_length+bar_start>=512+8-13*2-4*2-6)
  bar_length=512+8-13*2-4*2-6-bar_start;
  draw_bar(i, samp, bar_start, bar_length);

  /* draw loop start / end */
  if (samp->sample_type&3) {
    unsigned long p1=samp->sample_loop_start, p2=samp->sample_loop_start+samp->sample_loop_length;
    /* start */
    if (p1>=samp->start_0 &&
	(unsigned long long)p1<<32<((unsigned long long)(samp->start_0)<<32)+512ll*samp->inc_0) {
      unsigned long x;
      x=((unsigned long long)(p1-samp->start_0)<<32)/samp->inc_0;
      draw_line(i->X_ecran, samp->pixmap, i->context, XDEP+x, 8, XDEP+x, 8+128, RED);
      draw_plot(i->X_ecran, samp->pixmap, i->context, XDEP+x-1, 8+125, 3, RED);
    }
    /* end */
    if (p2>=samp->start_0 &&
	(unsigned long long)p2<<32<((unsigned long long)(samp->start_0)<<32)+512ll*samp->inc_0) {
      unsigned long x;
      x=((unsigned long long)(p2-samp->start_0)<<32)/samp->inc_0;
      draw_line(i->X_ecran, samp->pixmap, i->context, XDEP+x, 8, XDEP+x, 8+128, RED);
      draw_plot(i->X_ecran, samp->pixmap, i->context, XDEP+x-1, 8, 3, RED);
    }
  }
}

void draw_sample(INTERFACE *i, sample *samp)
{
  draw_box(i->X_ecran, samp->pixmap, i->context, 8, 8, 512, 128, LIGHTBLUE);
  draw_line(i->X_ecran, samp->pixmap, i->context, 7, 8, 7, 128+8, GREY);
  draw_line(i->X_ecran, samp->pixmap, i->context, 8+512+1, 8, 8+512+1, 128+8, GREY);
  /* cheecking */
  if (!samp->sample_data) {
    /* we draw the bar anyway (for example when cutting a whole sample, you'll have length=0, but if you
     * were in big big zoom, you'll still have a tiny tiny bar, which is no good)
     */
    draw_bar(i, samp, 0, 512+8-13*2-4*2-6);
    return;
  }

  if (samp->sample_type & 16)
    draw_sample_16(i, samp);
  else
    draw_sample_8(i, samp);

  /* draw the pos of the current pos */
  if (samp->cur_pos_0>=samp->start_0 &&
      (unsigned long long)samp->cur_pos_0<<32<((unsigned long long)(samp->start_0)<<32)+512ll*samp->inc_0) {
    unsigned long x=0;
    x=((unsigned long long)(samp->cur_pos_0-samp->start_0)<<32)/samp->inc_0;
    draw_line(i->X_ecran, samp->pixmap, i->context, XDEP+x, 8, XDEP+x, 8+128, BLACK);
  }
}

void draw_loop_start(INTERFACE *i, sample *samp)
{
  /* don't look for a buffer overflow, there is none in this program (and by the it's not suid, so...)  */
  char s[15];
  draw_box(i->X_ecran, samp->pixmap, i->context, XI+9+6*10+5+13+3-5*6, YI+1+5+4+8, (4+8)*6-4-16, 12, 3);
  sprintf(s, "%8.8X", samp->sample_loop_start);
  draw_string(i->X_ecran, samp->pixmap, i->context, XI+9+6*10+5+13+3-5*6+2, YI+1+5+4+8+10, s, i->little, BLUE);
}

void draw_loop_end(INTERFACE *i, sample *samp)
{
  char s[15];
  draw_box(i->X_ecran, samp->pixmap, i->context, XI+9+6*10+5+13+3-5*6, YI+1+5+4+13+3+13+6+8, (4+8)*6-4-16, 12, 3);
  sprintf(s, "%8.8X", samp->sample_loop_start+samp->sample_loop_length);
  draw_string(i->X_ecran, samp->pixmap, i->context, XI+9+6*10+5+13+3-5*6+2, YI+1+5+4+13+3+13+6+8+10, s, i->little, BLUE);
}

void draw_fine_tune(INTERFACE *i, sample *samp)
{
  char s[15];
  draw_box(i->X_ecran, samp->pixmap, i->context, XFR+9+6*10+5+13+3-2*6, YI+1+5+4+8, (4+4)*6-4-16, 12, 3);
  sprintf(s, "%4d", samp->sample_fine_tune);
  draw_string(i->X_ecran, samp->pixmap, i->context, XFR+9+6*10+5+13+3-2*6+2, YI+1+5+4+8+10, s, i->little, BLUE);
}

void draw_relative_tone(INTERFACE *i, sample *samp)
{
  char s[15];
  extern char *name_note[12];
  int note=4*12+(int)samp->sample_relative_note_number;
  draw_box(i->X_ecran, samp->pixmap, i->context, XFR+9+6*10+5+13+3-2*6, YI+1+5+4+13+3+13+6+8, (4+3)*6-4-16, 12, 3);
  sprintf(s, "%s%d", name_note[note%12], note/12);
  draw_string(i->X_ecran, samp->pixmap, i->context, XFR+9+6*10+5+13+3-2*6+2, YI+1+5+4+13+3+13+6+8+10, s, i->little, BLUE);
}

void draw_volume(INTERFACE *i, sample *samp)
{
  char s[15];
  draw_box(i->X_ecran, samp->pixmap, i->context, XVP+9+6*10+5+13+3-3*6, YI+1+5+4+8, (4+2)*6-4-16, 12, 3);
  sprintf(s, "%2.2X", samp->sample_volume);
  draw_string(i->X_ecran, samp->pixmap, i->context, XVP+9+6*10+5+13+3-3*6+2, YI+1+5+4+8+10, s, i->little, BLUE);
}

void draw_panning(INTERFACE *i, sample *samp)
{
  char s[15];
  draw_box(i->X_ecran, samp->pixmap, i->context, XVP+9+6*10+5+13+3-3*6, YI+1+5+4+13+3+13+6+8, (4+2)*6-4-16, 12, 3);
  sprintf(s, "%2.2X", samp->sample_panning);
  draw_string(i->X_ecran, samp->pixmap, i->context, XVP+9+6*10+5+13+3-3*6+2, YI+1+5+4+13+3+13+6+8+10, s, i->little, BLUE);
}

void draw_8_16_bits(INTERFACE *i, sample *samp)
{
  draw_3d_box_around(i->X_ecran, samp->pixmap, i->context, XHS+9+6*10+5-3*6, YI+1+5+4+11-9+1, 10, 10, LIGHTBLUE,
		     samp->sample_type&16 ? UP_3D : DOWN_3D);
  draw_3d_box_around(i->X_ecran, samp->pixmap, i->context, XHS+9+6*10+5-3*6, YI+1+5+4+8+11+15-9+1, 10, 10, LIGHTBLUE,
		     samp->sample_type&16 ? DOWN_3D : UP_3D);
  draw_3d_box_around(i->X_ecran, samp->pixmap, i->context, XHS+9+6*10+5-3*6, YI+1+5+4+8+11+15-9+25+1, 10, 10, LIGHTBLUE,
		     samp->mode_3_0 ? DOWN_3D : UP_3D);
}

void draw_use_loop(INTERFACE *i, sample *samp)
{
  draw_3d_box_around(i->X_ecran, samp->pixmap, i->context, XL+6*10+4, YI+5+4+18+4-5, 10, 10, LIGHTBLUE,
		     (samp->sample_type&3)==1 ? DOWN_3D : UP_3D);
  draw_3d_box_around(i->X_ecran, samp->pixmap, i->context, XL+6*10+4, YI+5+4+18+4+15-5, 10, 10, LIGHTBLUE,
		     (samp->sample_type&3)==2 ? DOWN_3D : UP_3D);
}

void draw_subwin_4(INTERFACE *i, sample *samp)
{
  draw_3d_box_around(i->X_ecran, samp->pixmap, i->context, 8+8*6-3, 128+8+8+13+4+4, 10, 10, LIGHTBLUE,
		     samp->subsubwin==0 ? DOWN_3D : UP_3D);
  draw_3d_box_around(i->X_ecran, samp->pixmap, i->context, 8+19*6-3, 128+8+8+13+4+4, 10, 10, LIGHTBLUE,
		     samp->subsubwin==1 ? DOWN_3D : UP_3D);
  draw_3d_box_around(i->X_ecran, samp->pixmap, i->context, 8+(42-8-5)*6-3, 128+8+8+13+4+4, 10, 10, LIGHTBLUE,
		     samp->subsubwin==2 ? DOWN_3D : UP_3D);
}

void draw_view_0(INTERFACE *i, sample *samp)
{
  draw_loop_start(i, samp);
  draw_loop_end(i, samp);
  draw_fine_tune(i, samp);
  draw_relative_tone(i, samp);
  draw_volume(i, samp);
  draw_panning(i, samp);
  draw_8_16_bits(i, samp);
  draw_use_loop(i, samp);
}

void draw_record_mixing_rate(INTERFACE *i, sample *samp)
{
  char s[15];
  draw_box(i->X_ecran, samp->pixmap, i->context, XI+9+6*10+5+13+3-4*6, YI+1+5+4+8, (4+5)*6-4-16, 12, 3);
  sprintf(s, "%5d", samp->record_rate);
  draw_string(i->X_ecran, samp->pixmap, i->context, XI+9+6*10+5+13+3-4*6+2, YI+1+5+4+8+10, s, i->little, BLUE);
}

void draw_record_8_16_bits(INTERFACE *i, sample *samp)
{
  draw_3d_box_around(i->X_ecran, samp->pixmap, i->context, XI+9+6*8, YI+1+5+4+8+11-5+10*3-9, 10, 10, LIGHTBLUE,
		     samp->record_16b ? UP_3D : DOWN_3D);
  draw_3d_box_around(i->X_ecran, samp->pixmap, i->context, XI+9+6*8, YI+1+5+4+8+11-5+10*5-9-5, 10, 10, LIGHTBLUE,
		     samp->record_16b ? DOWN_3D : UP_3D);
}

int fragment_size[11]={		/* 7, ..., 17 makes 11 values */
  /* fragment size is in [7..17] says mikmod 3.0.3, so... */
  128, 256, 512, 1024, 2048, 4096, 8192, 16384, 32768, 65536, 131072
};

void draw_record_fragment_size(INTERFACE *i, sample *samp)
{
  char s[15];
  draw_box(i->X_ecran, samp->pixmap, i->context, XFS+9+6*10+5+13+3-1*6, YI+1+5+4+8, (4+6)*6-4-16, 12, 3);
  sprintf(s, "%6d", fragment_size[samp->record_frag_size-7]);
  draw_string(i->X_ecran, samp->pixmap, i->context, XFS+9+6*10+5+13+3-1*6+2, YI+1+5+4+8+10, s, i->little, BLUE);
}

void draw_record_nb_fragments(INTERFACE *i, sample *samp)
{
  char s[15];
  draw_box(i->X_ecran, samp->pixmap, i->context, XFS+9+6*10+5+13+3-1*6, YI+1+5+4+13+3+13+6+8, (4+3)*6-4-16, 12, 3);
  sprintf(s, "%3d", samp->record_nb_frags);
  draw_string(i->X_ecran, samp->pixmap, i->context, XFS+9+6*10+5+13+3-1*6+2, YI+1+5+4+13+3+13+6+8+10, s, i->little, BLUE);
}

void draw_record_micro_line(INTERFACE *i, sample *samp)
{
  draw_3d_box_around(i->X_ecran, samp->pixmap, i->context, XMI+4, YI+5+4, 10, 10, LIGHTBLUE,
		     samp->record_micro_line ? UP_3D : DOWN_3D);
  draw_3d_box_around(i->X_ecran, samp->pixmap, i->context, XMI+4+6*12, YI+5+4, 10, 10, LIGHTBLUE,
		     samp->record_micro_line ? DOWN_3D : UP_3D);
}

void draw_record_input_volume(INTERFACE *i, sample *samp)
{
  char s[15];
  draw_box(i->X_ecran, samp->pixmap, i->context, XMI+9+6*10+5+13+3-4*6, YV+1+5+4+8, (4+3)*6-4-16, 12, 3);
  sprintf(s, "%3d", samp->record_input_volume);
  draw_string(i->X_ecran, samp->pixmap, i->context, XMI+9+6*10+5+13+3-4*6+2, YV+1+5+4+8+10, s, i->little, BLUE);
}


void draw_view_1(INTERFACE *i, sample *samp)
{
  draw_record_mixing_rate(i, samp);
  draw_record_8_16_bits(i, samp);
  draw_record_fragment_size(i, samp);
  draw_record_nb_fragments(i, samp);
  draw_record_micro_line(i, samp);
  draw_record_input_volume(i, samp);
}

void draw_view_2(INTERFACE *i, sample *samp)
{
  /* nothing */
}

void (*draw_view[3])(INTERFACE *, sample *)= {
  draw_view_0,
  draw_view_1,
  draw_view_2
};

void sample_put_data(INTERFACE *i, sample *samp)
{
  /* draw the sample */
  draw_sample(i, samp);
  draw_subwin_4(i, samp);
  draw_sample_size(i, samp);
  /* draw the 0 view */
  draw_view[samp->subsubwin](i, samp);
}

static int c0[16][4]={
  {4, 4, 512+8, 128+8},
  {4, 128+8+8, 13, 13},
  {4+512+8-13, 128+8+8, 13, 13},
  {4+13+4, 128+8+8, 512+8-13*2-4*2, 13},
  {4, 128+8+8+13+4, 6*(57-8-5*2)+8, 18},
  {XBOZ+4+6*57+8+4, 128+8+8+13+4, 6*5+8, 18},
  {XBOZ+4+6*57+8+4+6*5+8+4, 128+8+8+13+4, 6*4+8, 18},
  {XBOZ+4+6*57+8+4+30+48, 128+8+8+13+4, 6*4+8, 18},
  {XI+5, YI+5, 148-6*6, 74},
  {XFR+5, YI+5, 148-6*6+3*6-4*6, 74},
  {XVP+5, YI+5, 148-6*6+3*6-7*6, 74},
  {XHS+5, YI+5, 148-6*6+3*6-7*6-3*6-2, 74},
  {XL, YI+5, 6*10+8+10+1, 18+12+18+4},
  {XL, YI+5+18+4+18+4+12, 3*6+12, 18},
  {XL+6*3+12+4, YI+5+18+4+18+4+12, 4*6+12, 18},
  {XL+6*3+12+4+4*6+12+4, YI+5+18+4+18+4+12, 5*6+12, 18},
};

static int c1[13][4]={
  {4, 4, 512+8, 128+8},
  {4, 128+8+8, 13, 13},
  {4+512+8-13, 128+8+8, 13, 13},
  {4+13+4, 128+8+8, 512+8-13*2-4*2, 13},
  {4, 128+8+8+13+4, 6*(57-8-5*2)+8, 18},
  {XBOZ+4+6*57+8+4, 128+8+8+13+4, 6*5+8, 18},
  {XBOZ+4+6*57+8+4+6*5+8+4, 128+8+8+13+4, 6*4+8, 18},
  {XBOZ+4+6*57+8+4+30+48, 128+8+8+13+4, 6*4+8, 18},
  {XI+5, YI+5, 148-8*6, 74},
  {XFS+5, YI+5, 148-6*6+3*6-1*6, 74},
  {XMI, YI+5, 6*20+8+10, 18},
  {XMI+5, YV+5, 148-6*6+3*6-7*6, 74-35},
  {XG, YI+5, 74+50, 74},
};

void around_sub_0(INTERFACE *i, sample *samp, int type)
{
  int color=type==IN ? WHITE : BLACK;
  draw_rectangle(i->X_ecran, samp->pixmap, i->context, c0[samp->subwindow][0]-2, c0[samp->subwindow][1]-2,
		 c0[samp->subwindow][2]+4, c0[samp->subwindow][3]+4, 2, color);
  draw_rectangle(i->X_ecran, samp->window, i->context, c0[samp->subwindow][0]-2, c0[samp->subwindow][1]-2,
		 c0[samp->subwindow][2]+4, c0[samp->subwindow][3]+4, 2, color);
}

void around_sub_1(INTERFACE *i, sample *samp, int type)
{
  int color=type==IN ? WHITE : BLACK;
  draw_rectangle(i->X_ecran, samp->pixmap, i->context, c1[samp->subwindow][0]-2, c1[samp->subwindow][1]-2,
		 c1[samp->subwindow][2]+4, c1[samp->subwindow][3]+4, 2, color);
  draw_rectangle(i->X_ecran, samp->window, i->context, c1[samp->subwindow][0]-2, c1[samp->subwindow][1]-2,
		 c1[samp->subwindow][2]+4, c1[samp->subwindow][3]+4, 2, color);
}

void (*around_sample[3])(INTERFACE *, sample *, int)={
  around_sub_0,
  around_sub_1,
  around_sub_0
};

void in_out_sample_0(INTERFACE *i, sample *samp, int type)
{
  int col[16]={
    GREY, LIGHTBLUE, LIGHTBLUE, GREY, GREY, LIGHTBLUE, LIGHTBLUE, LIGHTBLUE, GREY, GREY, GREY, GREY, GREY,
    LIGHTBLUE, LIGHTBLUE, LIGHTBLUE
  };
  draw_3d_box_around(i->X_ecran, samp->pixmap, i->context, c0[samp->subwindow][0], c0[samp->subwindow][1],
		     c0[samp->subwindow][2], c0[samp->subwindow][3], col[samp->subwindow], type);
  draw_3d_box_around(i->X_ecran, samp->window, i->context, c0[samp->subwindow][0], c0[samp->subwindow][1],
		     c0[samp->subwindow][2], c0[samp->subwindow][3], col[samp->subwindow], type);
}

void in_out_sample_1(INTERFACE *i, sample *samp, int type)
{
  int col[13]={
    GREY, LIGHTBLUE, LIGHTBLUE, GREY, GREY, LIGHTBLUE, LIGHTBLUE, LIGHTBLUE, GREY, GREY, GREY, GREY, LIGHTBLUE
  };
  draw_3d_box_around(i->X_ecran, samp->pixmap, i->context, c1[samp->subwindow][0], c1[samp->subwindow][1],
		     c1[samp->subwindow][2], c1[samp->subwindow][3], col[samp->subwindow], type);
  draw_3d_box_around(i->X_ecran, samp->window, i->context, c1[samp->subwindow][0], c1[samp->subwindow][1],
		     c1[samp->subwindow][2], c1[samp->subwindow][3], col[samp->subwindow], type);
}

void (*in_out_sample[3])(INTERFACE *, sample *, int)={
  in_out_sample_0,
  in_out_sample_1,
  in_out_sample_0
};

/* put the name of the window (i am not sure of this code, shoud read books to know if it's correct */
void put_name_sample(INTERFACE *i, XM *xm, instrument *inst, sample *samp)
{
  XTextProperty proper;
  char z[200];
  char *d=&z[0];
  int xn, in, sn;
  /* those for are bad, even if no bug can occurs (well, in fact it happens once, but i passed
   * a wrong instrument, so of course...). We should have a stop condition, which is not the case.
   * If a bug was here, could have infinite loop.
   */
  for (xn=0; ;xn++)
    if (xm==i->xms[xn])
      break;
  for (in=0; ;in++)
    if (inst==xm->instruments[in])
      break;
  for (sn=0; ;sn++)
    if (samp==&inst->sample_headers[sn])
      break;
  sprintf(z, "Xsoundtrack : sample editor - XM %2.2X - Instrument %2.2X - Sample %2.2X", xn+1, in+1, sn+1);
  if (!XStringListToTextProperty(&d, 1, &proper))
    fprintf(stderr, "sample.put_name_sample error with XStringToTextProperty\n");
  else {
    XSetWMName(i->X_ecran, samp->window, &proper);
    XFree(proper.value);
  }
}

/* return 1 if ok 0 otherwise */
int init_sample_interface(INTERFACE *i, XM *xm)
{
  instrument *inst;
  sample *samp;

  /* first of all, get the good instrument (create a header if necessary) */
  if (!(inst=xm->instruments[xm->start_5+xm->cur_pos_5])) {
    sample dum;
    int i;
    if(!(inst=xm->instruments[xm->start_5+xm->cur_pos_5]=(instrument *)malloc(sizeof(instrument))))
      return 0;
    memset(inst, 0, sizeof(instrument));
    memset(&dum, 0, sizeof(sample));
    dum.sample_volume=0x40;
    dum.sample_panning=0x80;
    for (i=0; i<16; i++)
      inst->sample_headers[i]=dum;
  }

  samp=&inst->sample_headers[xm->start_6+xm->cur_pos_6];
  if (samp->is_shown) {
    XBell(i->X_ecran, 0);
    return 1;
  }

  /* create the menu window */
  samp->window=XCreateSimpleWindow(i->X_ecran, DefaultRootWindow(i->X_ecran),
				   0, 0, LARGEUR, HAUTEUR, 3, 3,
				   BlackPixel(i->X_ecran, DefaultScreen(i->X_ecran)));
  XMapWindow(i->X_ecran, samp->window);
  XSelectInput(i->X_ecran, samp->window, KeyPressMask|ExposureMask);

  put_name_sample(i, xm, inst, samp);

  /* the pixmap */
  samp->pixmap=XCreatePixmap(i->X_ecran, DefaultRootWindow(i->X_ecran), LARGEUR, HAUTEUR,
			     DefaultDepth(i->X_ecran, DefaultScreen(i->X_ecran)));
  draw_box(i->X_ecran, samp->pixmap, i->context, 0, 0, LARGEUR, HAUTEUR, BLACK);

  init_sample_pixmap(i, samp);

  /* init the vars */
  samp->is_shown=1;
  samp->mode=MOVING;
  samp->subwindow=0;
  samp->subsubwin=0;
  if (samp->sample_type&16)
    samp->max_inc_0=samp->sample_length>>1;
  else
    samp->max_inc_0=samp->sample_length;
  if (samp->max_inc_0<512)
    samp->max_inc_0=512;
  samp->inc_0=((unsigned long long)samp->max_inc_0)<<(32-9);
  samp->start_0=0;
  samp->cur_pos_0=0;
  samp->down_0=3;
  samp->cut_in_use=0;
  samp->down_3=4;
  samp->cur_pos_4=0;
  samp->down__0_4=8;
  samp->down__1_4=8;
  samp->cur_pos_0_0=0;
  samp->cur_pos_0_1=0;
  samp->cur_pos_0_2=0;
  samp->cur_pos_0_3=0;
  samp->cur_pos_0_4=0;
  samp->cur_pos_1_0=0;
  samp->cur_pos_1_1=0;
  samp->cur_pos_1_3=0;
  samp->mode_3_0=0;
  samp->right_0_3=12;
  samp->up_0_4=5;
  samp->down_0_4=13;
  samp->record_rate=8000;
  samp->record_16b=0;
  samp->record_frag_size=10;
  samp->record_nb_frags=10;
  samp->right_1_1=11;
  samp->record_micro_line=0;
  samp->record_input_volume=100;
  samp->left_1_4=11;
  samp->up_1_4=5;

  /* by default, it's the view 0 */
  init_view[samp->subsubwin](i, samp);
  sample_put_data(i, samp);
  around_sample[samp->subsubwin](i, samp, IN);

  return 1;
}

void draw_samp(INTERFACE *i, sample *samp)
{
  XCopyArea(i->X_ecran, samp->pixmap, samp->window, i->context, 0, 0, LARGEUR, HAUTEUR, 0, 0);
}

/* what = 0 prev. sample, 1 next sample, 2 sample of prev inst, 3 sample of next inst */
void other_sample(INTERFACE *i, sample *samp, int what)
{
  void interface_subwin_5(INTERFACE *, XM *, KeySym);
  void interface_subwin_6(INTERFACE *, XM *, KeySym);
  extern XM *the_xm;			/* it is set by the event-dispatcher */
  sample *to;
  instrument *to_inst;

  switch(what) {
    case 0 :
      interface_subwin_6(i, the_xm, XK_Up);
      break;
    case 1 :
      interface_subwin_6(i, the_xm, XK_Down);
      break;
    case 2 :
      interface_subwin_5(i, the_xm, XK_Up);
      break;
    case 3 :
      interface_subwin_5(i, the_xm, XK_Down);
      break;
  }

  if (!(to_inst=the_xm->instruments[the_xm->start_5+the_xm->cur_pos_5])) {
    sample dum;
    int l;
    if(!(to_inst=the_xm->instruments[the_xm->start_5+the_xm->cur_pos_5]=(instrument *)malloc(sizeof(instrument)))) {
      perror("sample.other_sample malloc failed");
      XBell(i->X_ecran, 0);
      return;
    }
    memset(to_inst, 0, sizeof(instrument));
    memset(&dum, 0, sizeof(sample));
    dum.sample_volume=0x40;
    dum.sample_panning=0x80;
    for (l=0; l<16; l++)
      to_inst->sample_headers[l]=dum;
  }

  to=&to_inst->sample_headers[the_xm->start_6+the_xm->cur_pos_6];
  if (to==samp)
    return;

  to->window=samp->window;
  to->pixmap=samp->pixmap;
  samp->is_shown=0;
  to->is_shown=1;
  to->mode=MOVING;
  to->subwindow=0;
  to->subsubwin=0;
  if (to->sample_type&16)
    to->max_inc_0=to->sample_length>>1;
  else
    to->max_inc_0=to->sample_length;
  if (to->max_inc_0<512)
    to->max_inc_0=512;
  to->inc_0=((unsigned long long)to->max_inc_0)<<(32-9);
  to->start_0=0;
  to->cur_pos_0=0;
  to->down_0=3;
  to->cut_in_use=0;
  to->down_3=4;
  to->cur_pos_4=0;
  to->down__0_4=8;
  to->down__1_4=8;
  to->cur_pos_0_0=0;
  to->cur_pos_0_1=0;
  to->cur_pos_0_2=0;
  to->cur_pos_0_3=0;
  to->cur_pos_0_4=0;
  to->cur_pos_1_0=0;
  to->cur_pos_1_1=0;
  to->cur_pos_1_3=0;
  to->mode_3_0=0;
  to->right_0_3=12;
  to->up_0_4=5;
  to->down_0_4=13;
  to->record_rate=8000;
  to->record_16b=0;
  to->record_frag_size=10;
  to->record_nb_frags=10;
  to->right_1_1=11;
  to->record_micro_line=0;
  to->record_input_volume=100;
  to->left_1_4=11;
  to->up_1_4=5;
  draw_box(i->X_ecran, to->pixmap, i->context, 0, 0, LARGEUR, HAUTEUR, BLACK);
  init_sample_pixmap(i, to);
  init_view[to->subsubwin](i, to);
  sample_put_data(i, to);
  around_sample[to->subsubwin](i, to, IN);
  draw_samp(i, to);
  put_name_sample(i, the_xm, to_inst, to);
}

void keypress_sample(INTERFACE *i, sample *samp, XKeyEvent *event)
{
  extern unsigned int status;           /* re-use it, why not, huh ? */
  char dum[50];
  KeySym ks;

  status=event->state;

  XLookupString(event, dum, 50, &ks, (XComposeStatus *)0);

  if (ks==NoSymbol) {
    fprintf(stderr, "sample.keypress_sample : warning ks=NoSymbol\n");
    return;
  }

  if (ks==XK_Escape && samp->mode==EDIT) {
    if (i->in_record)
      return sample_subwin[samp->subsubwin][samp->subwindow](i, samp, ks);

    samp->mode=MOVING;
    sample_exit_subwin[samp->subsubwin][samp->subwindow](i, samp);
    return in_out_sample[samp->subsubwin](i, samp, UP_3D);
  }

  if (samp->mode==EDIT)
    return sample_subwin[samp->subsubwin][samp->subwindow](i, samp, ks);

  switch(ks) {
    case XK_Return :
      samp->mode=EDIT;
      in_out_sample[samp->subsubwin](i, samp, DOWN_3D);
      sample_enter_subwin[samp->subsubwin][samp->subwindow](i, samp);
      break;
      /* one change here (i code that after instrument.c which was done after interface.c */
      /* now, we have no more switches but function pointers. Smaller switch, faster code (i think) */
    case XK_Right :
      right_handle[samp->subsubwin][samp->subwindow](i, samp);
      break;
    case XK_Left :
      left_handle[samp->subsubwin][samp->subwindow](i, samp);
      break;
    case XK_Down :
      down_handle[samp->subsubwin][samp->subwindow](i, samp);
      break;
    case XK_Up :
      up_handle[samp->subsubwin][samp->subwindow](i, samp);
      break;
    case XK_Page_Up : /* we wanna see previous sample (same instrument or next instrument) */
      if (status && status!=ControlMask)
	break;
      other_sample(i, samp, status==ControlMask?2:0);
      break;
    case XK_Page_Down : /* we wanna see next sample (same instrument or next instrument) */
      if (status && status!=ControlMask)
	break;
      other_sample(i, samp, status==ControlMask?3:1);
      break;
  }
}

void sample_handle_event(INTERFACE *i, sample *samp, XEvent *event)
{
  switch(event->type) {
    case Expose :
      draw_samp(i, samp);
      break;
    case KeyPress :
      keypress_sample(i, samp, &event->xkey);
  }
}
