/*
 * This file is part of xsoundtrack - a sound tracker for Linux.
 * Sed - july august 1998.
 * This is total free software.
 *-------------------------------------
 * definition of a channel (had to put it in a new file because xm.h and mixer.h use it and they would include
 * each other if it would have stayed in mixer.h
 */

#ifndef _CHANNELS_DEF_H_
#define _CHANNELS_DEF_H_

#include "xm.h"

/* the channel structure */
typedef struct {
  instrument *instrument;
  sample *sample;
  unsigned long long sample_position;
  unsigned long long increment;
  char in_use;
  int left_volume, right_volume; /* 0..64 */
  int volume_point;
  int panning_point;
  int envelop_volume;
  int envelop_panning;
  int volume;
  int panning;
  int cut_key;
  char closed;	/* put to 1 if the mixer has not to take care of it
		 * (when you put it to 1, don't forget to put in_use to 0)
		 */
  int last_instrument; /* the last instrument put in a channel (init to 0, don't know what has to be) */
  /* those bytes reflect what was in the pattern */
  int volume_effect;
  int effect_type;
  int effect_parameter;
  /* some effects will use the last parameter that was given, so we must save them */
  /* take care ! They are never reseted, so you could have a module playing a certain
   * way at the creation time, and when replaying it, it would have another behavior.
   */
  int old_volume_slide;
  int old_fine_volume_slide_up;
  int old_fine_volume_slide_down;
  int old_global_volume_slide;
  int old_panning_slide;
  /* data for e6 effect */
  int loop_point_is_set;
  int looped_nb;
  int loop_row;
  int loop_pattern;
  int loop_max;
  int has_looped;
} channel;

#endif /* _CHANNELS_DEF_H_ */
